'From Jasmine-rc1 of 7 October 2004 [latest update: #276] on 8 September 2005 at 7:58:59 pm'!
"Change Set:		Croquet-alife
Date:			8 September 2005
Author:			Dave Faught

This is a try at building a simple artificial life simulation for Croquet Jasmine.

It is heavily based on the bons-alife package by Ken Boucher from SqueakMap.  It is a 2 dimensional simulation represented in 3D.  It is made somewhat 3D by using a rolling TFractalTerrain and having the alife cells follow its contours.

This version added the picnic simulation."!

TSpace subclass: #TBonsAlifeBuilder
	instanceVariableNames: 'rectangle ground space '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-alife'!
TFrame subclass: #TBonsAlifeCell
	instanceVariableNames: 'velocity height '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-alife'!
Object subclass: #TBonsAlifeDistro
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-alife'!
TeapotMorph subclass: #TBonsAlifeMorph
	instanceVariableNames: 'ground '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-alife'!
TBonsAlifeBuilder subclass: #TCongaLineBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-alife'!
TBonsAlifeCell subclass: #TCongaLineCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-alife'!
TBonsAlifeBuilder subclass: #THuntBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-alife'!
TBonsAlifeCell subclass: #TPredatorCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-alife'!
TPredatorCell subclass: #TPreyCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-alife'!

!TBonsAlifeBuilder methodsFor: 'as yet unclassified' stamp: 'daf 9/6/2005 18:17'!
addCells: n
	"Add a bunch of new alife cells."

	| a |
	n timesRepeat: [
		a := self cellType new.
		space addChild: a.
		a randomPositionIn: self rectangle maxVelocity: 0]
! !

!TBonsAlifeBuilder methodsFor: 'as yet unclassified' stamp: 'daf 9/6/2005 18:18'!
addCells: n ofType: aCellType
	"Add a bunch of new alife Cells."

	| a  |
	n timesRepeat: [
		a := aCellType new.
		space addChild: a.
		a randomPositionIn: self rectangle maxVelocity: 0]
! !

!TBonsAlifeBuilder methodsFor: 'as yet unclassified' stamp: 'kdb 6/25/2004 12:08'!
cellType
	"This method should always be overridden"
	^CircleCell! !

!TBonsAlifeBuilder methodsFor: 'as yet unclassified' stamp: 'kdb 6/25/2004 12:07'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color white! !

!TBonsAlifeBuilder methodsFor: 'as yet unclassified' stamp: 'daf 9/7/2005 21:58'!
defaultGroundTexture
	^'lawn.BMP'
	! !

!TBonsAlifeBuilder methodsFor: 'as yet unclassified' stamp: 'daf 9/5/2005 15:17'!
defaultSize
	^200
	! !

!TBonsAlifeBuilder methodsFor: 'as yet unclassified' stamp: 'daf 9/6/2005 21:33'!
defaultWindowPos
	^0@0
	! !

!TBonsAlifeBuilder methodsFor: 'as yet unclassified' stamp: 'daf 9/5/2005 13:58'!
ground

	^ ground! !

!TBonsAlifeBuilder methodsFor: 'as yet unclassified' stamp: 'daf 9/7/2005 21:59'!
initializeInTSpace: inSpace withName: newName
	" build a new TSpace "

	| tframe url fileName seed txtr mat p1 p2 win objects mesh bBox height |
	super initialize.
	space _ self.
	space url: 'http://www.reed.com/TeaLand/spaces/alife', newName, '.tea'.
"Transcript clear."

	" Ground. "
	url := 'http://www.reed.com/TeaLand/AlifeMorph/alife', newName, 'Ground.tea'.
	ground := CroquetData loadURL: url reuseExisting: false.
	ground ifNil: [
		" Add Terrain. "
		fileName := (FileDirectory pathFrom:
			{FileDirectory default pathName. 'Content'. 'Textures'. self defaultGroundTexture}).
		txtr _ TTexture new initializeWithFileName: fileName mipmap: true shrinkFit: false.
		txtr uvScale: 16.0@16.0.
		seed _ 12345.
		ground := TFractalTerrain initializeSize: 32 smoothness: 0.940 heightScale: 0.27 randomSeed: seed.
		ground genGrid.
		ground buildMeshWithTexture: txtr.
		ground scale: self defaultSize.
		ground translationX: 0 y: -5.0 z: 0.0.
		ground boundsDepth: 2.
		ground initBounds.
		TExporter export: ground asBinary: url.
	].
	space addChild: ground.

	"Find the 2D rectangle of the ground mesh"
	objects := ground frameChildren.
	mesh := ( objects select: [:each | (each isMemberOf: TMesh)] ) first.
	bBox := mesh boundSphere box.
	rectangle := Rectangle origin: (bBox origin x) @ (bBox origin z)
			corner: (bBox corner x) @ (bBox corner z). 

	"Make a sky box"
	tframe _ TSkyBox new initializeWithFileName: 'MLL'.
	tframe translationX: 0 y: tframe boundingBox extentY / 2.0 - 50.0 z: 0.0.
	space addChild: tframe.
	tframe stopStepping.

	"Make a light"
	self makeLight.

	"Build the portals and windows"
	mat _ TMaterial new.

	p1 _ TPortal new.
	p1 material: mat.

	p2 _ TPortal new.
	"p2 rotationAroundY: 180."
	"p2 translationX: 0.0 y: 0.0 z: 30.0."
	p2 material: mat.

	win _ TWindow new.
	height _ CroquetGlobals theTeapotMorph ground heightAt: (self defaultWindowPos).
	win translationX: (self defaultWindowPos x) y: (height + 1) z: (self defaultWindowPos y).
	win contents: p1.
	win rectFront: (self makeTextureText: newName).
	inSpace addChild: win.
	win closeContents.

	win _ TWindow new.
	win rotationAroundY: 180.
	height _ space ground heightAt: (20.0 @ -20.0).
	win translationX: 20.0 y: (height + 1) z: -20.0.
	win contents: p2.
	space addChild: win.

	p1 linkPortal: p2.

	"add some cells to the simulation"
	self addCells: self numberOfCells.
	(self respondsTo: #initializeLate) ifTrue: [ self initializeLate. ].

	"start a couple of scripts"
	space startScript: #objectEntered: when: #objectEnter.
	space startScript: #objectLeft: when: #objectLeave.

	"A little in-space debugging"
"	tframe := TPrimitiveText new text: (self rectangle printString).
	space addChild: tframe."

	^space
! !

!TBonsAlifeBuilder methodsFor: 'as yet unclassified' stamp: 'daf 8/25/2005 10:43'!
makeLight
	| light tframe |
	light _ TLight new.
	tframe _ TSpinner new.
	tframe translationX: -10 y:0.0 z: 0.0.
	tframe rotationAroundZ: 120.
	"This is to avoid some odd lighting effects"
	tframe rotateBy: 1 around: 1@0@0.
	tframe matNil.
	tframe contents: light.
	space addChild: tframe.! !

!TBonsAlifeBuilder methodsFor: 'as yet unclassified' stamp: 'daf 9/4/2005 11:27'!
makeTextureText: txt

	| canvas |

	canvas _ FormCanvas extent: 128@128.
	canvas fillColor: (Color white).
	canvas drawString: txt at: 5@5 font: nil color: (Color blue).
	^ TTexture new initializeWithForm: (canvas form)
				mipmap: true
				shrinkFit: false.
! !

!TBonsAlifeBuilder methodsFor: 'as yet unclassified' stamp: 'kdb 6/25/2004 12:09'!
numberOfCells
	^20! !

!TBonsAlifeBuilder methodsFor: 'as yet unclassified' stamp: 'daf 9/6/2005 15:51'!
objectEntered: obj
	"script run when an object enters the TSpace"

	| objects |
	"is the new object a TAvatar"
	(obj isMemberOf: TAvatar) ifFalse: [ ^nil ].

	"find all the objects of cellType and start them up"
	objects := self frameChildren select: [:each | (each isMemberOf: self cellType)].
	objects do: [:each | (each stepperActive) ifFalse: [ each startStepping ]. ].! !

!TBonsAlifeBuilder methodsFor: 'as yet unclassified' stamp: 'daf 9/6/2005 17:49'!
objectLeft: obj
	"script run when an object leaves the TSpace"

	| objects |
	"is the object a TAvatar"
"really should check if there are any TAvatars left"
	(obj isMemberOf: TAvatar) ifFalse: [ ^nil ].

	"find all the objects of cellType and stop them"
	objects := self frameChildren select: [:each | (each isMemberOf: self cellType)].
	objects do: [:each | (each stepperActive) ifTrue: [ each stopStepping ]. ].! !

!TBonsAlifeBuilder methodsFor: 'as yet unclassified' stamp: 'daf 9/2/2005 20:06'!
rectangle

	^ rectangle! !

!TBonsAlifeBuilder methodsFor: 'as yet unclassified' stamp: 'daf 9/3/2005 13:18'!
stepTime
	"As fast as possible."
	^ 80! !


!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 9/3/2005 14:27'!
addSketch: aSketch

	| txtr url frame |
	txtr _ TTexture new initializeWithFileName: aSketch, '.gif'.
	url := 'http://www.reed.com/TeaLand/AlifeMorph/alife', aSketch, 'Body.tea'.

	frame _ (CroquetData loadURL: url reuseExisting: false).
	frame ifNil:[
		frame _ Cursor wait showWhile:[self makePopoutObjectFrom: txtr].
		TExporter export: frame asBinary:url].
	self addChild: frame.

	"Find the height of the Popout object mesh"
	height := frame boundSphere box extentY.
! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'kdb 6/25/2004 12:16'!
adjustVelocityBy: acceleration
	self velocity: (self velocity + acceleration).! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 9/6/2005 18:10'!
atRandom: number 
	^self randMin: 1 max: number
! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 8/31/2005 21:18'!
avoidWalls
	self moveAwayFrom: (self rectangle corner x @ self position y) towardsDistance: self safeDistanceWall.
	self moveAwayFrom: (self rectangle origin x @ self position y) towardsDistance: self safeDistanceWall.
	self moveAwayFrom: (self position x @ self rectangle corner y) towardsDistance: self safeDistanceWall.
	self moveAwayFrom: (self position x @ self rectangle origin y) towardsDistance: self safeDistanceWall.! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 9/4/2005 11:12'!
bounceIn: aRect
	"Move this atom one step along its velocity vector and make it bounce if it goes outside the given rectangle. Return true if it is bounced."

	| p vx vy px py bounced bearingInDegrees |
	p _ self position.
	vx _ velocity x.		vy _ velocity y.
	px _ p x + vx.		py _ p y + vy.
	bounced _ false.
"Transcript show: teaObjectName;
		show: '  pos='; show: p printString;
		show: '  vel='; show: velocity printString;
		show: '  newPos='; show: (px @ py) printString; cr."
	px > aRect right ifTrue: [
		px _ aRect right - (px - aRect right).
		vx _ velocity x negated.
		bounced _ true].
	py > aRect bottom ifTrue: [
		py _  aRect bottom - (py - aRect bottom).
		vy _ velocity y negated.
		bounced _ true].
	px < aRect left ifTrue: [
		px _ aRect left - (px - aRect left).
		vx _ velocity x negated.
		bounced _ true].
	py < aRect top ifTrue: [
		py _  aRect top - (py - aRect top).
		vy _ velocity y negated.
		bounced _ true].
	self position: px @ py.
	bounced ifTrue: [self velocity: vx @ vy].

	p := self position.
	vx _ velocity x.		vy _ velocity y.
	px _ p x + vx.		py _ p y - vy.
	bearingInDegrees := (p bearingToPoint: (px @ py)) asFloat - 90.0.
	self rotationAroundY: bearingInDegrees.

	^ bounced
! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 9/1/2005 16:28'!
bounds

	| bBox |
	bBox := self boundingBox.
	^ Rectangle origin: (bBox origin x) @ (bBox origin z)
			corner: (bBox corner x) @ (bBox corner z). ! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 9/1/2005 16:39'!
brothers
	| objects | 
	objects := self parent frameChildren.
	^objects select: [:each | (each isMemberOf: self class) and: [(each == self) not]].
! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'kdb 6/25/2004 12:17'!
brothersSorted
	^self brothers asSortedCollection: [:a :b | (self position dist: a position) < (self position dist: b position)].
! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 8/25/2005 10:27'!
defaultScale
	^1.! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'kdb 6/25/2004 12:18'!
distanceTo: aPosition
	^self position dist: aPosition! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 9/1/2005 16:39'!
enemies
	| objects | 
	objects := self parent frameChildren.
	^objects select: [:each | (each isMemberOf: self enemyClass)].
! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'kdb 6/25/2004 20:08'!
enemiesSorted
	^self enemies asSortedCollection: [:a :b | (self position dist: a position) < (self position dist: b position)].
! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 9/5/2005 14:23'!
fall

	| trans ht dist floorHeight |
	floorHeight _ self parent ground heightAt: self position.
	trans _ self translation.
	dist _ trans y + height - floorHeight.

"Transcript show: teaObjectName;
		show: '  position='; show: self position printString;
		show: '  distance='; show: dist printString;
		show: '  translation='; show: trans printString; cr."

" ---- Calculate distance to the current floor."
	dist = height ifFalse:[
		ht _ trans y + height - dist.
		trans y > ht ifTrue:[ trans y - ht > 0.5 ifTrue:[ ht _ trans y - 0.5.].].
		trans y: ht].
	self translation = trans ifFalse: [ self translation: trans ].
! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 9/6/2005 21:41'!
initialize

	super initialize.
	self visible: false.
	(self respondsTo: #defaultSketch) ifTrue: [ self addSketch: (self defaultSketch). ]
		ifFalse: [ self visible: true. height:= 1. ].
	self scale: self defaultScale.
! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 9/3/2005 11:28'!
makePopoutObjectFrom: aTTexture

	| bbForm mat b3dMesh mesh scale tfm aForm rot |
	"Convert the form"
	aForm := aTTexture targetForm.
	bbForm := Form extent: aForm extent asSmallerPowerOfTwo depth: 32.
	aForm displayScaledOn: bbForm in: (bbForm boundingBox insetBy: 1).
	"Smear the borders of the texture a bit to prevent problems in texture mapping"
	bbForm smearFill: 10. "pixels - less is faster but more is safer"

	"The material"
	mat _ TMaterial meta new.
	mat meta ambientColor: #(1 1 1 1) asFloatArray.
	mat diffuseColor: #(1 1 1 1) asFloatArray.

	mat texture: aTTexture.
	mat textureMode: GLModulate.

	"The b3d mesh"
	b3dMesh := CroquetGlobals theTeapotMorph makePopoutMeshFrom: aForm.
	scale := 0.01.
	rot := 0.
	tfm := (B3DRotation axis: 1@0@0 angle: 180) asMatrix4x4.
	tfm := tfm composeWith: (B3DRotation axis: 0@1@0 angle: rot) asMatrix4x4.
	tfm := tfm composeWith: (B3DMatrix4x4 withScale: scale@scale@scale).
	tfm := tfm composeWith: (B3DMatrix4x4 withOffset: (aForm width * -0.5) @ (aForm height * -0.5) @ 0).
	b3dMesh transformBy: tfm.

	"The TMesh"
	mesh := TMesh new.
	mesh initializeWithVertices: b3dMesh vertices 
		alias: nil 
		norms: b3dMesh vertexNormals
		textureUV: b3dMesh texCoords
		faceGroups: {1. b3dMesh zeroBasedFaceGroup}
		material: mat.
	mesh initBounds.
	^ mesh
! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'kdb 6/25/2004 12:20'!
maxSpeed
	^2! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'kdb 6/25/2004 20:59'!
moveAwayFrom: aPosition
	self moveAwayFrom: aPosition towardsDistance: self safeDistanceFoe
	 ! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'kdb 6/25/2004 20:58'!
moveAwayFrom: aPosition towardsDistance: aDistance
	| myPosition speed bearingInRadians distanceToSafety |
	myPosition := self position.
	distanceToSafety := aDistance - (myPosition dist: aPosition).
	distanceToSafety <= 0 ifTrue: [^self].
	speed := distanceToSafety sqrt. "as you get away, slow down, no need to rush"
	bearingInRadians := ((myPosition bearingToPoint: aPosition) asFloat + 90.0) degreesToRadians.
	self adjustVelocityBy: (bearingInRadians cos @ bearingInRadians sin) * speed.


	 ! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'kdb 7/3/2004 20:27'!
moveRandomly
	self adjustVelocityBy: (self randomSpeed @ self randomSpeed).

	 ! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'kdb 6/25/2004 21:01'!
moveTowards: aPosition
	self moveTowards: aPosition towardsDistance: self safeDistanceFriend! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 9/3/2005 10:36'!
moveTowards: aPosition towardsDistance: aDistance
	| myPosition distance speed bearingInRadians |
	myPosition := self position.
	distance := (myPosition dist: aPosition) - aDistance.
	(distance <= 0) ifTrue: [^self velocity: (0@0)]. 
	speed := distance sqrt. "as you get closer, slow down, no need to rush"
	speed > self maxSpeed ifTrue: [speed := self maxSpeed].
	bearingInRadians := ((myPosition bearingToPoint: aPosition) asFloat - 90.0) degreesToRadians.
"Transcript show: teaObjectName;
		show: '  adjVelVec='; show: ((bearingInRadians cos @ bearingInRadians sin) * speed) printString;
		show: '  velocity='; show: velocity printString; cr."

	self adjustVelocityBy: (bearingInRadians cos @ bearingInRadians sin) * speed.

	 ! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 8/31/2005 21:07'!
position
	^(self globalPosition x) @ (self globalPosition z)! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 9/3/2005 10:55'!
position: aPoint

	self translationX: (aPoint x) y: (self globalPosition y) z: (aPoint y).
! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 9/6/2005 18:12'!
randMin: rMin max: rMax
	"use the parent grounds random generator for consistency"

	^ self parent ground randMin: rMin max: rMax
! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 9/6/2005 18:04'!
random 
	^self randMin: -1 max: 1 . "(-1,0,+1)"
! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 9/6/2005 18:14'!
randomPositionIn: aRectangle maxVelocity: maxVelocity
	"Give this atom a random position and velocity."

	| origin extent |
	origin _ aRectangle origin.
	extent _ (aRectangle extent - self bounds extent) rounded.
	self position:
		(origin x + (self atRandom: (extent x))) @
		(origin y + (self atRandom: (extent y))).
	velocity _
		(maxVelocity - (self atRandom: (2 * maxVelocity))) @
		(maxVelocity - (self atRandom: (2 * maxVelocity))).
! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 9/6/2005 18:15'!
randomSpeed 
	^(self atRandom: ((self maxSpeed *2)+1))  - (self maxSpeed +1). 
! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 9/2/2005 20:06'!
rectangle

	^ self parent rectangle
! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 9/2/2005 20:32'!
safeDistanceFoe
	^7

	 ! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 9/2/2005 20:32'!
safeDistanceFriend
	^5
"	^safeDistanceFriend"


	 ! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 9/3/2005 14:18'!
step

"	Transcript show: teaObjectName;
			show: '  initVelocity='; show: self velocity printString;
			show: '  position='; show: self position printString;
			show: '  3Dposition='; show: globalPosition printString; cr."
	self setVelocity.
	self bounceIn: self rectangle.
"	Transcript show: teaObjectName;
			show: '  endVelocity='; show: self velocity printString;
			show: '  position='; show: self position printString;
			show: '  3Dposition='; show: globalPosition printString; cr."
	self fall.
! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 9/3/2005 13:17'!
stepTime
	^80! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 9/6/2005 17:30'!
stepperActive

	^ stepperActive
! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 8/16/2005 22:20'!
velocity

	^ velocity! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 8/16/2005 22:21'!
velocity: newVelocity

	velocity _ newVelocity.! !

!TBonsAlifeCell methodsFor: 'as yet unclassified' stamp: 'daf 9/2/2005 20:22'!
worldSize
	^self parent rectangle extent.! !


!TBonsAlifeDistro methodsFor: 'as yet unclassified' stamp: 'daf 9/4/2005 11:51'!
seeClassSide! !


!TBonsAlifeDistro class methodsFor: 'as yet unclassified' stamp: 'daf 9/4/2005 11:53'!
changeSetBaseFileNames
	"TBonsAlifeDistro changeSetBaseFileNames"
	^self changeSetFullFileNames collect: [ :ea | FileDirectory localNameFor: ea ]! !

!TBonsAlifeDistro class methodsFor: 'as yet unclassified' stamp: 'daf 9/4/2005 11:51'!
changeSetDirectory
	^FileDirectory default! !

!TBonsAlifeDistro class methodsFor: 'as yet unclassified' stamp: 'daf 9/4/2005 11:53'!
changeSetFullFileNames
	"TBonsAlifeDistro changeSetFullFileNames"
	| dir |
	dir _ self changeSetDirectory.
	^self changeSets collect: [ :s | 
		dir fullNameFor: (dir lastNameFor: s extension: 'cs') ]
! !

!TBonsAlifeDistro class methodsFor: 'as yet unclassified' stamp: 'daf 9/4/2005 11:52'!
changeSets
	^{
'Croquet-alife'.
}
! !

!TBonsAlifeDistro class methodsFor: 'as yet unclassified' stamp: 'daf 9/4/2005 11:54'!
makeSAR
	"
	TBonsAlifeDistro makeSAR
	"
	| sar result sarName |
	sar _ ZipArchive new.
	self changeSetFullFileNames do: [ :fileName | sar addFile: fileName as: (FileDirectory localNameFor: fileName) ].
	self otherFullFileNames do: [ :fileName | sar addFile: fileName as: (FileDirectory localNameFor: fileName) ].

	sar addString: self preambleText as: 'install/preamble'.
"	sar addString: self postscriptText as: 'install/postscript'."

	result _ StandardFileMenu newFile.
	result ifNil: [ ^nil ].
	sarName _ (result directory fullNameFor: result name).
	sar writeToFileNamed: sarName.
! !

!TBonsAlifeDistro class methodsFor: 'as yet unclassified' stamp: 'daf 9/7/2005 22:03'!
otherBaseFileNames
	" TBonsAlifeDistro otherFileNames "
	^#('pig1.gif' 'sheep2.gif' 'ant10.gif')
! !

!TBonsAlifeDistro class methodsFor: 'as yet unclassified' stamp: 'daf 9/4/2005 11:55'!
otherDirectory
	^FileDirectory on: (FileDirectory pathFromURI: 'Content/Textures/')! !

!TBonsAlifeDistro class methodsFor: 'as yet unclassified' stamp: 'daf 9/4/2005 11:55'!
otherFullFileNames
	"TBonsAlifeDistro otherFullFileNames"
	| dir |
	dir _ self otherDirectory.
	^self otherBaseFileNames collect: [ :s | 
		dir fullNameFor: s ]
! !

!TBonsAlifeDistro class methodsFor: 'as yet unclassified' stamp: 'daf 9/4/2005 11:59'!
preambleText
	"
	TBonsAlifeDistro preambleText
	"

	^String streamContents: [ :stream |
		stream nextPutAll: '| gifDir |'; cr.
		stream nextPutAll: 'gifDir := FileDirectory pathFromURI: ''Content/Textures/''';
			nextPut: $.; cr.
		self changeSetBaseFileNames do: [ :csName |
			stream nextPutAll: 'self fileInMemberNamed: ';
				print: csName; nextPut: $.; cr ].
		self otherBaseFileNames do: [ :otName |
			stream nextPutAll: 'self extractMember: '; print: otName;
				nextPutAll: ' toFileNamed: gifDir,'; print: otName; nextPut: $.; cr ].
	]
! !


!TBonsAlifeMorph methodsFor: 'as yet unclassified' stamp: 'daf 9/4/2005 11:24'!
bonsAlifeAbout

	| dlg |
	dlg _ CUserDialog new.
	dlg label: 'About Bons Alife for Croquet'.
	dlg message: '
                          Bons Alife for Croquet
                          --------------------------

Artificial life simulations are fun to play with.  These demos are based on
Ken Boucher''s bons-alife package on SqueakMap, adapted to Croquet
by Dave Faught.'.

	dlg messageText allowEditing: false.
	dlg messageText hResizing: #shrinkWrap; vResizing: #shrinkWrap.

	dlg addButton: 'okay' value: #cancel.

	dlg run: #cancel centerAt: self extent / 2.0.
! !

!TBonsAlifeMorph methodsFor: 'as yet unclassified' stamp: 'daf 8/17/2005 21:25'!
destroyProjectList
	"get rid of the project list display"

	| |
	self tweakWorld activeProject projectList destroy.
	self tweakWorld activeProject project destroy.
! !

!TBonsAlifeMorph methodsFor: 'as yet unclassified' stamp: 'daf 9/5/2005 14:36'!
ground

	^ ground! !

!TBonsAlifeMorph methodsFor: 'as yet unclassified' stamp: 'daf 9/7/2005 22:02'!
initializeDefaultSpace
	" TBonsAlifeMorph new openInWorld "

	| space tframe url fileName seed |
	space _ TSpace new.
	space url: 'http://www.reed.com/TeaLand/spaces/bonsAlife.tea'.

	" Ground. "
	url := 'http://www.reed.com/TeaLand/BonsAlifeMorph/alifeGround.tea'.
	ground := CroquetData loadURL: url reuseExisting: false.
	ground ifNil: [
		" Add Terrain. "
		fileName := (FileDirectory pathFrom:
			{FileDirectory default pathName. 'Content'. 'Textures'. 'lawn.BMP'}).
		txtr _ TTexture new initializeWithFileName: fileName mipmap: true shrinkFit: false.
		txtr uvScale: 16.0@16.0.
		seed _ 12345.
		ground := TFractalTerrain initializeSize: 32 smoothness: 0.940 heightScale: 0.27 randomSeed: seed.
		ground genGrid.
		ground buildMeshWithTexture: txtr.
		ground boundsDepth: 2.
		ground initBounds.
		ground scale: 100.
		ground translationX: 0 y: -5.0 z: 0.0.
		TExporter export: ground asBinary: url.
	].
	space addChild: ground.

	"Make a sky box"
	tframe _ TSkyBox new initializeWithFileName: 'MLL'.
	tframe translationX: 0 y: tframe boundingBox extentY / 2.0 - 50.0 z: 0.0.
	space addChild: tframe.
	tframe stopStepping.

	"Make a light"
	self makeLight: space.

	self makeMirror: space.

	THuntBuilder basicNew initializeInTSpace: space withName: 'babeMagnet'.
	TCongaLineBuilder basicNew initializeInTSpace: space withName: 'picnic'.

	self initializeTweakWorld: [ :aWorld | aWorld onBootstrap.
		self startScript: #destroyProjectList.
		self startScript: #bonsAlifeAbout.
	].

	^space
! !


!TBonsAlifeMorph class methodsFor: 'as yet unclassified' stamp: 'daf 9/6/2005 22:05'!
descriptionForPartsBin
	^ self partName:	'ALife'
		categories:		#('Croquet')
		documentation:	'Croquet Browser'
		sampleImageForm: TForm defaultForm.
! !


!TCongaLineBuilder methodsFor: 'as yet unclassified' stamp: 'daf 9/6/2005 21:27'!
cellType
	^TCongaLineCell! !

!TCongaLineBuilder methodsFor: 'as yet unclassified' stamp: 'daf 9/7/2005 22:01'!
defaultGroundTexture
	^'Rchecker.bmp'
	! !

!TCongaLineBuilder methodsFor: 'as yet unclassified' stamp: 'daf 9/7/2005 22:02'!
defaultSize
	^50! !

!TCongaLineBuilder methodsFor: 'as yet unclassified' stamp: 'daf 9/6/2005 21:36'!
defaultWindowPos
	^-10@0
! !


!TCongaLineCell methodsFor: 'as yet unclassified' stamp: 'daf 9/7/2005 22:01'!
defaultSketch

	^ 'ant10'! !

!TCongaLineCell methodsFor: 'as yet unclassified' stamp: 'daf 9/6/2005 21:28'!
safeDistanceFoe
	^10! !

!TCongaLineCell methodsFor: 'as yet unclassified' stamp: 'daf 9/7/2005 22:08'!
safeDistanceFriend
	^10! !

!TCongaLineCell methodsFor: 'as yet unclassified' stamp: 'daf 9/6/2005 21:59'!
setVelocity
	| redline bros |
	bros := self brothersSorted. 
	((self distanceTo: bros first position) > self safeDistanceFriend) ifTrue:
		[self moveTowards: bros first position].
	((self distanceTo: bros first position) < (self safeDistanceFriend * 3 / 4)) ifTrue:
		[self moveAwayFrom: bros first position].
	((self distanceTo: bros second position) > self safeDistanceFriend) ifTrue:
		[self moveTowards: bros second position].
	((self distanceTo: bros second position) < (self safeDistanceFriend *3 / 4 )) ifTrue:
		[self moveAwayFrom: bros second position].
	self moveAwayFrom: bros third position.
	self moveAwayFrom: bros fourth position.
	redline := (((velocity x squared) + (velocity y squared)) sqrt) / self maxSpeed.
	redline > 1 ifTrue: [velocity := velocity / redline].! !


!THuntBuilder methodsFor: 'as yet unclassified' stamp: 'daf 8/31/2005 21:35'!
cellType
	^TPredatorCell! !

!THuntBuilder methodsFor: 'as yet unclassified' stamp: 'daf 8/31/2005 21:35'!
defaultSize
	^200! !

!THuntBuilder methodsFor: 'as yet unclassified' stamp: 'daf 9/6/2005 21:34'!
defaultWindowPos
	^-20@0
! !

!THuntBuilder methodsFor: 'as yet unclassified' stamp: 'daf 9/1/2005 16:51'!
initializeLate

	self addCells: 2 ofType: TPreyCell! !

!THuntBuilder methodsFor: 'as yet unclassified' stamp: 'daf 9/5/2005 14:26'!
numberOfCells
	^20! !

!THuntBuilder methodsFor: 'as yet unclassified' stamp: 'daf 9/6/2005 17:37'!
objectEntered: obj
	"script run when an object enters the TSpace"

	| objects |
	super objectEntered: obj.

	"is the new object a TAvatar"
	(obj isMemberOf: TAvatar) ifFalse: [ ^nil ].

	"find all the objects of cellType and start them up"
	objects := self frameChildren select: [:each | (each isMemberOf: TPreyCell)].
	objects do: [:each | (each stepperActive) ifFalse: [ each startStepping ]. ].! !

!THuntBuilder methodsFor: 'as yet unclassified' stamp: 'daf 9/6/2005 17:48'!
objectLeft: obj
	"script run when an object leaves the TSpace"

	| objects |
	super objectLeft: obj.

	"is the object a TAvatar"
	(obj isMemberOf: TAvatar) ifFalse: [ ^nil ].

	"find all the objects of cellType and stop them"
	objects := self frameChildren select: [:each | (each isMemberOf: TPreyCell)].
	objects do: [:each | (each stepperActive) ifTrue: [ each stopStepping ]. ].! !


!TPredatorCell methodsFor: 'as yet unclassified' stamp: 'daf 9/3/2005 11:23'!
defaultSketch

	^ 'sheep2'! !

!TPredatorCell methodsFor: 'as yet unclassified' stamp: 'daf 8/31/2005 21:37'!
enemyClass
	^TPreyCell
	! !

!TPredatorCell methodsFor: 'as yet unclassified' stamp: 'daf 9/3/2005 20:35'!
maxSpeed
	^2! !

!TPredatorCell methodsFor: 'as yet unclassified' stamp: 'daf 8/31/2005 21:32'!
safeDistanceFoe
	^0
! !

!TPredatorCell methodsFor: 'as yet unclassified' stamp: 'daf 9/2/2005 20:31'!
safeDistanceFriend
	^10! !

!TPredatorCell methodsFor: 'as yet unclassified' stamp: 'daf 9/2/2005 20:31'!
safeDistanceWall
	^10! !

!TPredatorCell methodsFor: 'as yet unclassified' stamp: 'daf 9/3/2005 10:43'!
setVelocity
	| redline bros |
	bros := self brothersSorted.
	((self distanceTo: bros first position) > self safeDistanceFriend) ifTrue:
		[
"Transcript show: teaObjectName;
		show: '  brosPos='; show: bros first position printString; cr."
			self moveTowards: bros first position].
	((self distanceTo: bros first position) < (self safeDistanceFriend * 3 / 4)) ifTrue:
		[self moveAwayFrom: bros first position towardsDistance: self safeDistanceFriend].
	self moveTowards: self enemiesSorted first position towardsDistance: self safeDistanceFoe.
	redline := (((velocity x squared) + (velocity y squared)) sqrt) / self maxSpeed.
	redline > 1 ifTrue: [velocity := velocity / redline].
	! !


!TPreyCell methodsFor: 'as yet unclassified' stamp: 'daf 8/31/2005 21:33'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color white! !

!TPreyCell methodsFor: 'as yet unclassified' stamp: 'daf 8/31/2005 21:33'!
defaultSize
	^5 @ 5.! !

!TPreyCell methodsFor: 'as yet unclassified' stamp: 'daf 9/3/2005 13:45'!
defaultSketch

	^ 'pig1'! !

!TPreyCell methodsFor: 'as yet unclassified' stamp: 'daf 8/31/2005 21:38'!
enemyClass
	^TPredatorCell
	! !

!TPreyCell methodsFor: 'as yet unclassified' stamp: 'daf 9/2/2005 20:30'!
safeDistanceFoe
	^20
! !

!TPreyCell methodsFor: 'as yet unclassified' stamp: 'daf 9/2/2005 20:31'!
safeDistanceWall
	^10! !

!TPreyCell methodsFor: 'as yet unclassified' stamp: 'daf 8/31/2005 21:33'!
setVelocity
	| redline |
	self moveAwayFrom: self enemies first position.
	self avoidWalls.
	redline := (((velocity x squared) + (velocity y squared)) sqrt) / self maxSpeed.
	redline > 1 ifTrue: [velocity := velocity / redline].
	! !

